# Generated by Django 3.2.8 on 2022-04-05 17:36

import django.core.validators
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("effect_screening", "0016_auto_20220330_1828"),
    ]

    operations = [
        migrations.RemoveField(
            model_name="historicalsubjectscreening",
            name="mg_ssx_other",
        ),
        migrations.RemoveField(
            model_name="historicalsubjectscreening",
            name="mg_ssx_since_crag",
        ),
        migrations.RemoveField(
            model_name="subjectscreening",
            name="mg_ssx",
        ),
        migrations.RemoveField(
            model_name="subjectscreening",
            name="mg_ssx_other",
        ),
        migrations.RemoveField(
            model_name="subjectscreening",
            name="mg_ssx_since_crag",
        ),
        migrations.AddField(
            model_name="historicalsubjectscreening",
            name="any_other_mg_ssx",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="any other clinical symptoms/signs of symptomatic meningitis?",
            ),
        ),
        migrations.AddField(
            model_name="historicalsubjectscreening",
            name="any_other_mg_ssx_other",
            field=models.TextField(
                blank=True,
                help_text="If more than one, please separate each with a comma (,).",
                null=True,
                verbose_name="If 'YES', specify",
            ),
        ),
        migrations.AddField(
            model_name="historicalsubjectscreening",
            name="mg_gcs_lt_15",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a Glasgow Coma Scale (GCS) score of <15?",
            ),
        ),
        migrations.AddField(
            model_name="historicalsubjectscreening",
            name="mg_headache_nuchal_rigidity",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a headache and marked nuchal rigidity?",
            ),
        ),
        migrations.AddField(
            model_name="historicalsubjectscreening",
            name="mg_headache_vomiting",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a headache and vomiting?",
            ),
        ),
        migrations.AddField(
            model_name="historicalsubjectscreening",
            name="mg_seizures",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="seizures?",
            ),
        ),
        migrations.AddField(
            model_name="historicalsubjectscreening",
            name="mg_severe_headache",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a progressively severe headache?",
            ),
        ),
        migrations.AddField(
            model_name="subjectscreening",
            name="any_other_mg_ssx",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="any other clinical symptoms/signs of symptomatic meningitis?",
            ),
        ),
        migrations.AddField(
            model_name="subjectscreening",
            name="any_other_mg_ssx_other",
            field=models.TextField(
                blank=True,
                help_text="If more than one, please separate each with a comma (,).",
                null=True,
                verbose_name="If 'YES', specify",
            ),
        ),
        migrations.AddField(
            model_name="subjectscreening",
            name="mg_gcs_lt_15",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a Glasgow Coma Scale (GCS) score of <15?",
            ),
        ),
        migrations.AddField(
            model_name="subjectscreening",
            name="mg_headache_nuchal_rigidity",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a headache and marked nuchal rigidity?",
            ),
        ),
        migrations.AddField(
            model_name="subjectscreening",
            name="mg_headache_vomiting",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a headache and vomiting?",
            ),
        ),
        migrations.AddField(
            model_name="subjectscreening",
            name="mg_seizures",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="seizures?",
            ),
        ),
        migrations.AddField(
            model_name="subjectscreening",
            name="mg_severe_headache",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="a progressively severe headache?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalsubjectscreening",
            name="cd4_value",
            field=models.IntegerField(
                help_text="Eligible if CD4 count <100 cells/μL",
                null=True,
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(99),
                ],
                verbose_name="Most recent CD4 count",
            ),
        ),
        migrations.AlterField(
            model_name="historicalsubjectscreening",
            name="cm_in_csf_method",
            field=models.CharField(
                choices=[
                    ("india_ink", "Positive microscopy with India Ink"),
                    ("culture", "Positive culture"),
                    ("OTHER", "Other, please specify"),
                    ("N/A", "Not applicable"),
                ],
                default="N/A",
                max_length=25,
                verbose_name="If YES, by which method?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalsubjectscreening",
            name="on_fluconazole",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="Is the patient already taking high-dose fluconazole treatment (800-1200 mg/day) for ≥1 week?",
            ),
        ),
        migrations.AlterField(
            model_name="subjectscreening",
            name="cd4_value",
            field=models.IntegerField(
                help_text="Eligible if CD4 count <100 cells/μL",
                null=True,
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(99),
                ],
                verbose_name="Most recent CD4 count",
            ),
        ),
        migrations.AlterField(
            model_name="subjectscreening",
            name="cm_in_csf_method",
            field=models.CharField(
                choices=[
                    ("india_ink", "Positive microscopy with India Ink"),
                    ("culture", "Positive culture"),
                    ("OTHER", "Other, please specify"),
                    ("N/A", "Not applicable"),
                ],
                default="N/A",
                max_length=25,
                verbose_name="If YES, by which method?",
            ),
        ),
        migrations.AlterField(
            model_name="subjectscreening",
            name="on_fluconazole",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("not_answered", "Not answered")],
                default="not_answered",
                max_length=25,
                verbose_name="Is the patient already taking high-dose fluconazole treatment (800-1200 mg/day) for ≥1 week?",
            ),
        ),
    ]
