# Generated by Django 3.2.8 on 2022-04-05 17:36

import edc_model.validators.date
import edc_protocol.validators
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("effect_subject", "0032_auto_20220331_1639"),
    ]

    operations = [
        migrations.RemoveField(
            model_name="historicalmedicationadherence",
            name="pill_count_performed",
        ),
        migrations.RemoveField(
            model_name="medicationadherence",
            name="pill_count_performed",
        ),
        migrations.AlterField(
            model_name="historicalpatienthistory",
            name="fluconazole_dose",
            field=models.CharField(
                choices=[
                    ("800_mg_d", "Fluconazole, 800 mg/d"),
                    ("1200_mg_d", "Fluconazole, 1200 mg/d"),
                    ("OTHER", "Other Fluconazole dose, please specify below ..."),
                    ("N/A", "Not applicable"),
                ],
                help_text="in mg/d",
                max_length=25,
                verbose_name="If YES, Fluconazole dose (if taken < 1 week prior to randomisation):",
            ),
        ),
        migrations.AlterField(
            model_name="historicalsubjectvisit",
            name="last_alive_date",
            field=models.DateField(
                blank=True,
                null=True,
                validators=[
                    edc_protocol.validators.date_not_before_study_start,
                    edc_model.validators.date.date_not_future,
                ],
                verbose_name="Date participant last known alive",
            ),
        ),
        migrations.AlterField(
            model_name="historicalsubjectvisit",
            name="survival_status",
            field=models.CharField(
                choices=[("alive", "Alive"), ("dead", "Deceased"), ("unknown", "Unknown")],
                default="alive",
                max_length=10,
                null=True,
                verbose_name="Participant's survival status",
            ),
        ),
        migrations.AlterField(
            model_name="patienthistory",
            name="fluconazole_dose",
            field=models.CharField(
                choices=[
                    ("800_mg_d", "Fluconazole, 800 mg/d"),
                    ("1200_mg_d", "Fluconazole, 1200 mg/d"),
                    ("OTHER", "Other Fluconazole dose, please specify below ..."),
                    ("N/A", "Not applicable"),
                ],
                help_text="in mg/d",
                max_length=25,
                verbose_name="If YES, Fluconazole dose (if taken < 1 week prior to randomisation):",
            ),
        ),
        migrations.AlterField(
            model_name="subjectvisit",
            name="last_alive_date",
            field=models.DateField(
                blank=True,
                null=True,
                validators=[
                    edc_protocol.validators.date_not_before_study_start,
                    edc_model.validators.date.date_not_future,
                ],
                verbose_name="Date participant last known alive",
            ),
        ),
        migrations.AlterField(
            model_name="subjectvisit",
            name="survival_status",
            field=models.CharField(
                choices=[("alive", "Alive"), ("dead", "Deceased"), ("unknown", "Unknown")],
                default="alive",
                max_length=10,
                null=True,
                verbose_name="Participant's survival status",
            ),
        ),
    ]
